#!/bin/bash

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"
cd "$SCRIPT_DIR"

#The code generated by -g rust-server is opinionated and not great or modular
#We use -g rust to generate the client (which has better code) and then take only the models.
#It also generates methods which represent the operations we should have for each route in the API, but with client-side code.
#The method signatures are useful to us as we can keep them the same on the server, but with the actual serverside implementation

REL_OUTPUT_DIR="draxapp_api_codegen"
rm -rf "$PWD/${REL_OUTPUT_DIR}"


docker run --user $(id -u):$(id -g) --rm -v "${PWD}:/local" openapitools/openapi-generator-cli generate -i /local/drax-app.api.yml -g rust -o "/local/${REL_OUTPUT_DIR}" \
--config /local/openapi_generator_config.yml \
--http-user-agent "DraxAppServer/unknown" \
# --model-package api_models \
# --api-package draxapp_api_api
# --invoker-package draxapp_api_invoker \
# --package-name draxapp_api_package \


docker run --user $(id -u):$(id -g) --rm -v "${PWD}:/local" openapitools/openapi-generator-cli generate -i /local/drax-app.api.yml -g rust-server -o "/local/${REL_OUTPUT_DIR}/server" \
--config /local/openapi_generator_config.yml \
--http-user-agent "DraxAppServer/unknown" \
# --model-package api_models \
# --api-package draxapp_api_api
# --invoker-package draxapp_api_invoker \
# --package-name draxapp_api_package \




rm -rf "$PWD/draxapp_server/src/models"
mv -f "$PWD/${REL_OUTPUT_DIR}/src/models" "$PWD/draxapp_server/src/models" 